/* game-board-view.c generated by valac 0.45.91, the Vala compiler
 * generated from game-board-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/* game-board-view.vala
 *
 * Copyright © 2018 Jacob Humphrey
 *
 * This file is part of GNOME Four-in-a-row.
 *
 * GNOME Four-in-a-row is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Four-in-a-row is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Four-in-a-row. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <glib/gi18n-lib.h>

#define TYPE_GAME_BOARD_VIEW (game_board_view_get_type ())
#define GAME_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME_BOARD_VIEW, GameBoardView))
#define GAME_BOARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME_BOARD_VIEW, GameBoardViewClass))
#define IS_GAME_BOARD_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME_BOARD_VIEW))
#define IS_GAME_BOARD_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME_BOARD_VIEW))
#define GAME_BOARD_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME_BOARD_VIEW, GameBoardViewClass))

typedef struct _GameBoardView GameBoardView;
typedef struct _GameBoardViewClass GameBoardViewClass;
typedef struct _GameBoardViewPrivate GameBoardViewPrivate;

#define TYPE_BOARD (board_get_type ())
#define BOARD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOARD, Board))
#define BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOARD, BoardClass))
#define IS_BOARD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOARD))
#define IS_BOARD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOARD))
#define BOARD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOARD, BoardClass))

typedef struct _Board Board;
typedef struct _BoardClass BoardClass;
enum  {
	GAME_BOARD_VIEW_0_PROPERTY,
	GAME_BOARD_VIEW_NUM_PROPERTIES
};
static GParamSpec* game_board_view_properties[GAME_BOARD_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_PREFS (prefs_get_type ())
#define PREFS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS, Prefs))
#define PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS, PrefsClass))
#define IS_PREFS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS))
#define IS_PREFS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS))
#define PREFS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS, PrefsClass))

typedef struct _Prefs Prefs;
typedef struct _PrefsClass PrefsClass;
typedef enum  {
	TILE_PLAYER1 = 0,
	TILE_PLAYER2,
	TILE_CLEAR,
	TILE_CLEAR_CURSOR,
	TILE_PLAYER1_CURSOR,
	TILE_PLAYER2_CURSOR
} Tile;

#define TYPE_TILE (tile_get_type ())

#define TYPE_THEME (theme_get_type ())
typedef struct _Theme Theme;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	GAME_BOARD_VIEW_COLUMN_CLICKED_SIGNAL,
	GAME_BOARD_VIEW_NUM_SIGNALS
};
static guint game_board_view_signals[GAME_BOARD_VIEW_NUM_SIGNALS] = {0};

struct _GameBoardView {
	GtkDrawingArea parent_instance;
	GameBoardViewPrivate * priv;
};

struct _GameBoardViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _GameBoardViewPrivate {
	gint boardsize;
	gint tilesize;
	gint offset[6];
	GdkPixbuf* pb_tileset_raw;
	GdkPixbuf* pb_bground_raw;
	GdkPixbuf* pb_tileset;
	GdkPixbuf* pb_bground;
	Board* game_board;
	gint board_x;
	gint board_y;
};

struct _Theme {
	gchar* title;
	gchar* fname_tileset;
	gchar* fname_bground;
	gchar* grid_color;
	gchar* player1;
	gchar* player2;
	gchar* player1_win;
	gchar* player2_win;
	gchar* player1_turn;
	gchar* player2_turn;
};

static gint GameBoardView_private_offset;
static gpointer game_board_view_parent_class = NULL;

GType game_board_view_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GameBoardView, g_object_unref)
GType board_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Board, g_object_unref)
GameBoardView* game_board_view_new (Board* game_board);
GameBoardView* game_board_view_construct (GType object_type,
                                          Board* game_board);
GType prefs_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Prefs, g_object_unref)
Prefs* prefs_get_instance (void);
static void __lambda5_ (GameBoardView* self);
gboolean game_board_view_change_theme (GameBoardView* self);
static void ___lambda5__prefs_theme_changed (Prefs* _sender,
                                      gint theme_id,
                                      gpointer self);
gboolean game_board_view_load_pixmaps (GameBoardView* self);
static gint game_board_view_get_column (GameBoardView* self,
                                 gint xpos);
void game_board_view_draw_tile (GameBoardView* self,
                                gint r,
                                gint c);
static gboolean game_board_view_real_configure_event (GtkWidget* base,
                                               GdkEventConfigure* e);
GType tile_get_type (void) G_GNUC_CONST;
void game_board_view_refresh_pixmaps (GameBoardView* self);
static gboolean game_board_view_real_draw (GtkWidget* base,
                                    cairo_t* cr);
static void game_board_view_paint_tile (GameBoardView* self,
                                 cairo_t* cr,
                                 gint r,
                                 gint c);
static void game_board_view_draw_grid (GameBoardView* self,
                                cairo_t* cr);
GType theme_get_type (void) G_GNUC_CONST;
Theme* theme_dup (const Theme* self);
void theme_free (Theme* self);
void theme_copy (const Theme* self,
                 Theme* dest);
void theme_destroy (Theme* self);
gint prefs_get_theme_id (Prefs* self);
static void game_board_view_load_error (GameBoardView* self,
                                 const gchar* fname);
Tile board_get (Board* self,
                gint x,
                gint y);
void prefs_set_theme_id (Prefs* self,
                         gint value);
static gboolean game_board_view_real_button_press_event (GtkWidget* base,
                                                  GdkEventButton* e);
static void g_cclosure_user_marshal_BOOLEAN__INT (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data);
static void game_board_view_finalize (GObject * obj);

extern const Theme theme[5];

static inline gpointer
game_board_view_get_instance_private (GameBoardView* self)
{
	return G_STRUCT_MEMBER_P (self, GameBoardView_private_offset);
}

static void
__lambda5_ (GameBoardView* self)
{
#line 44 "../src/game-board-view.vala"
	game_board_view_change_theme (self);
#line 203 "game-board-view.c"
}

static void
___lambda5__prefs_theme_changed (Prefs* _sender,
                                 gint theme_id,
                                 gpointer self)
{
#line 43 "../src/game-board-view.vala"
	__lambda5_ ((GameBoardView*) self);
#line 213 "game-board-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/game-board-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 221 "game-board-view.c"
}

GameBoardView*
game_board_view_construct (GType object_type,
                           Board* game_board)
{
	GameBoardView * self = NULL;
	Prefs* _tmp0_;
	Prefs* _tmp1_;
	Board* _tmp2_;
#line 34 "../src/game-board-view.vala"
	g_return_val_if_fail (game_board != NULL, NULL);
#line 34 "../src/game-board-view.vala"
	self = (GameBoardView*) g_object_new (object_type, NULL);
#line 36 "../src/game-board-view.vala"
	gtk_widget_set_size_request ((GtkWidget*) self, 350, 350);
#line 37 "../src/game-board-view.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 38 "../src/game-board-view.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 40 "../src/game-board-view.vala"
	gtk_widget_set_events ((GtkWidget*) self, (GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK);
#line 43 "../src/game-board-view.vala"
	_tmp0_ = prefs_get_instance ();
#line 43 "../src/game-board-view.vala"
	_tmp1_ = _tmp0_;
#line 43 "../src/game-board-view.vala"
	g_signal_connect_object (_tmp1_, "theme-changed", (GCallback) ___lambda5__prefs_theme_changed, self, 0);
#line 46 "../src/game-board-view.vala"
	game_board_view_load_pixmaps (self);
#line 47 "../src/game-board-view.vala"
	_tmp2_ = _g_object_ref0 (game_board);
#line 47 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->game_board);
#line 47 "../src/game-board-view.vala"
	self->priv->game_board = _tmp2_;
#line 34 "../src/game-board-view.vala"
	return self;
#line 260 "game-board-view.c"
}

GameBoardView*
game_board_view_new (Board* game_board)
{
#line 34 "../src/game-board-view.vala"
	return game_board_view_construct (TYPE_GAME_BOARD_VIEW, game_board);
#line 268 "game-board-view.c"
}

static gint
game_board_view_get_column (GameBoardView* self,
                            gint xpos)
{
	gint result = 0;
	gint c = 0;
#line 50 "../src/game-board-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 52 "../src/game-board-view.vala"
	c = xpos / self->priv->tilesize;
#line 53 "../src/game-board-view.vala"
	if (c > 6) {
#line 54 "../src/game-board-view.vala"
		c = 6;
#line 285 "game-board-view.c"
	}
#line 55 "../src/game-board-view.vala"
	if (c < 0) {
#line 56 "../src/game-board-view.vala"
		c = 0;
#line 291 "game-board-view.c"
	}
#line 58 "../src/game-board-view.vala"
	result = c;
#line 58 "../src/game-board-view.vala"
	return result;
#line 297 "game-board-view.c"
}

void
game_board_view_draw_tile (GameBoardView* self,
                           gint r,
                           gint c)
{
#line 61 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 62 "../src/game-board-view.vala"
	gtk_widget_queue_draw_area ((GtkWidget*) self, (c * self->priv->tilesize) + self->priv->board_x, (r * self->priv->tilesize) + self->priv->board_y, self->priv->tilesize, self->priv->tilesize);
#line 309 "game-board-view.c"
}

static gboolean
game_board_view_real_configure_event (GtkWidget* base,
                                      GdkEventConfigure* e)
{
	GameBoardView * self;
	gboolean result = FALSE;
	gint allocated_width = 0;
	gint allocated_height = 0;
	gint size = 0;
#line 67 "../src/game-board-view.vala"
	self = (GameBoardView*) base;
#line 67 "../src/game-board-view.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 68 "../src/game-board-view.vala"
	allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 69 "../src/game-board-view.vala"
	allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 70 "../src/game-board-view.vala"
	size = MIN (allocated_width, allocated_height);
#line 71 "../src/game-board-view.vala"
	self->priv->tilesize = size / 7;
#line 72 "../src/game-board-view.vala"
	self->priv->boardsize = self->priv->tilesize * 7;
#line 73 "../src/game-board-view.vala"
	self->priv->board_x = (allocated_width - self->priv->boardsize) / 2;
#line 74 "../src/game-board-view.vala"
	self->priv->board_y = (allocated_height - self->priv->boardsize) / 2;
#line 76 "../src/game-board-view.vala"
	self->priv->offset[TILE_PLAYER1] = 0;
#line 77 "../src/game-board-view.vala"
	self->priv->offset[TILE_PLAYER2] = self->priv->tilesize;
#line 78 "../src/game-board-view.vala"
	self->priv->offset[TILE_CLEAR] = self->priv->tilesize * 2;
#line 79 "../src/game-board-view.vala"
	self->priv->offset[TILE_CLEAR_CURSOR] = self->priv->tilesize * 3;
#line 80 "../src/game-board-view.vala"
	self->priv->offset[TILE_PLAYER1_CURSOR] = self->priv->tilesize * 4;
#line 81 "../src/game-board-view.vala"
	self->priv->offset[TILE_PLAYER2_CURSOR] = self->priv->tilesize * 5;
#line 83 "../src/game-board-view.vala"
	game_board_view_refresh_pixmaps (self);
#line 84 "../src/game-board-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 85 "../src/game-board-view.vala"
	result = TRUE;
#line 85 "../src/game-board-view.vala"
	return result;
#line 359 "game-board-view.c"
}

gboolean
game_board_view_change_theme (GameBoardView* self)
{
	gboolean result = FALSE;
#line 88 "../src/game-board-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "../src/game-board-view.vala"
	if (!game_board_view_load_pixmaps (self)) {
#line 90 "../src/game-board-view.vala"
		result = FALSE;
#line 90 "../src/game-board-view.vala"
		return result;
#line 374 "game-board-view.c"
	}
#line 92 "../src/game-board-view.vala"
	game_board_view_refresh_pixmaps (self);
#line 93 "../src/game-board-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 94 "../src/game-board-view.vala"
	result = TRUE;
#line 94 "../src/game-board-view.vala"
	return result;
#line 384 "game-board-view.c"
}

static gboolean
game_board_view_real_draw (GtkWidget* base,
                           cairo_t* cr)
{
	GameBoardView * self;
	gboolean result = FALSE;
	gint r = 0;
	gint c = 0;
	GdkPixbuf* _tmp0_;
#line 97 "../src/game-board-view.vala"
	self = (GameBoardView*) base;
#line 97 "../src/game-board-view.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 101 "../src/game-board-view.vala"
	cairo_save (cr);
#line 102 "../src/game-board-view.vala"
	cairo_translate (cr, (gdouble) self->priv->board_x, (gdouble) self->priv->board_y);
#line 103 "../src/game-board-view.vala"
	_tmp0_ = self->priv->pb_bground;
#line 103 "../src/game-board-view.vala"
	gdk_cairo_set_source_pixbuf (cr, _tmp0_, (gdouble) 0, (gdouble) 0);
#line 104 "../src/game-board-view.vala"
	cairo_rectangle (cr, (gdouble) 0, (gdouble) 0, (gdouble) self->priv->boardsize, (gdouble) self->priv->boardsize);
#line 105 "../src/game-board-view.vala"
	cairo_paint (cr);
#line 106 "../src/game-board-view.vala"
	cairo_restore (cr);
#line 414 "game-board-view.c"
	{
		gboolean _tmp1_ = FALSE;
#line 108 "../src/game-board-view.vala"
		r = 0;
#line 108 "../src/game-board-view.vala"
		_tmp1_ = TRUE;
#line 108 "../src/game-board-view.vala"
		while (TRUE) {
#line 108 "../src/game-board-view.vala"
			if (!_tmp1_) {
#line 425 "game-board-view.c"
				gint _tmp2_;
#line 108 "../src/game-board-view.vala"
				_tmp2_ = r;
#line 108 "../src/game-board-view.vala"
				r = _tmp2_ + 1;
#line 431 "game-board-view.c"
			}
#line 108 "../src/game-board-view.vala"
			_tmp1_ = FALSE;
#line 108 "../src/game-board-view.vala"
			if (!(r < 7)) {
#line 108 "../src/game-board-view.vala"
				break;
#line 439 "game-board-view.c"
			}
			{
				gboolean _tmp3_ = FALSE;
#line 109 "../src/game-board-view.vala"
				c = 0;
#line 109 "../src/game-board-view.vala"
				_tmp3_ = TRUE;
#line 109 "../src/game-board-view.vala"
				while (TRUE) {
#line 109 "../src/game-board-view.vala"
					if (!_tmp3_) {
#line 451 "game-board-view.c"
						gint _tmp4_;
#line 109 "../src/game-board-view.vala"
						_tmp4_ = c;
#line 109 "../src/game-board-view.vala"
						c = _tmp4_ + 1;
#line 457 "game-board-view.c"
					}
#line 109 "../src/game-board-view.vala"
					_tmp3_ = FALSE;
#line 109 "../src/game-board-view.vala"
					if (!(c < 7)) {
#line 109 "../src/game-board-view.vala"
						break;
#line 465 "game-board-view.c"
					}
#line 110 "../src/game-board-view.vala"
					game_board_view_paint_tile (self, cr, r, c);
#line 469 "game-board-view.c"
				}
			}
		}
	}
#line 114 "../src/game-board-view.vala"
	cairo_save (cr);
#line 115 "../src/game-board-view.vala"
	cairo_translate (cr, (gdouble) self->priv->board_x, (gdouble) self->priv->board_y);
#line 116 "../src/game-board-view.vala"
	game_board_view_draw_grid (self, cr);
#line 117 "../src/game-board-view.vala"
	cairo_restore (cr);
#line 118 "../src/game-board-view.vala"
	result = FALSE;
#line 118 "../src/game-board-view.vala"
	return result;
#line 486 "game-board-view.c"
}

static void
game_board_view_draw_grid (GameBoardView* self,
                           cairo_t* cr)
{
#line 122 "../src/game-board-view.vala"
	static const gdouble dashes[2] = {4.0, 4.0};
#line 495 "game-board-view.c"
	gint i = 0;
	GdkRGBA color = {0};
	Prefs* _tmp0_;
	Prefs* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Theme _tmp4_;
	const gchar* _tmp5_;
	GdkRGBA _tmp6_;
#line 121 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 121 "../src/game-board-view.vala"
	g_return_if_fail (cr != NULL);
#line 124 "../src/game-board-view.vala"
	memset (&color, 0, sizeof (GdkRGBA));
#line 126 "../src/game-board-view.vala"
	_tmp0_ = prefs_get_instance ();
#line 126 "../src/game-board-view.vala"
	_tmp1_ = _tmp0_;
#line 126 "../src/game-board-view.vala"
	_tmp2_ = prefs_get_theme_id (_tmp1_);
#line 126 "../src/game-board-view.vala"
	_tmp3_ = _tmp2_;
#line 126 "../src/game-board-view.vala"
	_tmp4_ = theme[_tmp3_];
#line 126 "../src/game-board-view.vala"
	_tmp5_ = _tmp4_.grid_color;
#line 126 "../src/game-board-view.vala"
	gdk_rgba_parse (&color, _tmp5_);
#line 127 "../src/game-board-view.vala"
	_tmp6_ = color;
#line 127 "../src/game-board-view.vala"
	gdk_cairo_set_source_rgba (cr, &_tmp6_);
#line 128 "../src/game-board-view.vala"
	cairo_set_operator (cr, CAIRO_OPERATOR_SOURCE);
#line 129 "../src/game-board-view.vala"
	cairo_set_line_width (cr, (gdouble) 1);
#line 130 "../src/game-board-view.vala"
	cairo_set_line_cap (cr, CAIRO_LINE_CAP_BUTT);
#line 131 "../src/game-board-view.vala"
	cairo_set_line_join (cr, CAIRO_LINE_JOIN_MITER);
#line 132 "../src/game-board-view.vala"
	cairo_set_dash (cr, dashes, (gint) G_N_ELEMENTS (dashes), (gdouble) 0);
#line 539 "game-board-view.c"
	{
		gboolean _tmp7_ = FALSE;
#line 135 "../src/game-board-view.vala"
		i = 1;
#line 135 "../src/game-board-view.vala"
		_tmp7_ = TRUE;
#line 135 "../src/game-board-view.vala"
		while (TRUE) {
#line 135 "../src/game-board-view.vala"
			if (!_tmp7_) {
#line 550 "game-board-view.c"
				gint _tmp8_;
#line 135 "../src/game-board-view.vala"
				_tmp8_ = i;
#line 135 "../src/game-board-view.vala"
				i = _tmp8_ + 1;
#line 556 "game-board-view.c"
			}
#line 135 "../src/game-board-view.vala"
			_tmp7_ = FALSE;
#line 135 "../src/game-board-view.vala"
			if (!(i < 7)) {
#line 135 "../src/game-board-view.vala"
				break;
#line 564 "game-board-view.c"
			}
#line 136 "../src/game-board-view.vala"
			cairo_move_to (cr, (i * self->priv->tilesize) + 0.5, (gdouble) 0);
#line 137 "../src/game-board-view.vala"
			cairo_line_to (cr, (i * self->priv->tilesize) + 0.5, (gdouble) self->priv->boardsize);
#line 138 "../src/game-board-view.vala"
			cairo_move_to (cr, (gdouble) 0, (i * self->priv->tilesize) + 0.5);
#line 139 "../src/game-board-view.vala"
			cairo_line_to (cr, (gdouble) self->priv->boardsize, (i * self->priv->tilesize) + 0.5);
#line 574 "game-board-view.c"
		}
	}
#line 141 "../src/game-board-view.vala"
	cairo_stroke (cr);
#line 144 "../src/game-board-view.vala"
	cairo_set_dash (cr, NULL, (gint) 0, (gdouble) 0);
#line 145 "../src/game-board-view.vala"
	cairo_move_to (cr, (gdouble) 0, self->priv->tilesize + 0.5);
#line 146 "../src/game-board-view.vala"
	cairo_line_to (cr, (gdouble) self->priv->boardsize, self->priv->tilesize + 0.5);
#line 148 "../src/game-board-view.vala"
	cairo_stroke (cr);
#line 587 "game-board-view.c"
}

static void
game_board_view_load_error (GameBoardView* self,
                            const gchar* fname)
{
	GtkMessageDialog* dialog = NULL;
	GdkWindow* _tmp0_;
	GtkMessageDialog* _tmp1_;
#line 151 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/game-board-view.vala"
	g_return_if_fail (fname != NULL);
#line 154 "../src/game-board-view.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 154 "../src/game-board-view.vala"
	_tmp1_ = (GtkMessageDialog*) gtk_message_dialog_new (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp0_) : NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_WARNING, GTK_BUTTONS_CLOSE, g_dgettext (GETTEXT_PACKAGE, "Unable to load image:\n%s"), fname);
#line 154 "../src/game-board-view.vala"
	g_object_ref_sink (_tmp1_);
#line 154 "../src/game-board-view.vala"
	_g_object_unref0 (dialog);
#line 154 "../src/game-board-view.vala"
	dialog = _tmp1_;
#line 158 "../src/game-board-view.vala"
	gtk_dialog_run ((GtkDialog*) dialog);
#line 159 "../src/game-board-view.vala"
	gtk_widget_destroy ((GtkWidget*) dialog);
#line 151 "../src/game-board-view.vala"
	_g_object_unref0 (dialog);
#line 617 "game-board-view.c"
}

static void
game_board_view_paint_tile (GameBoardView* self,
                            cairo_t* cr,
                            gint r,
                            gint c)
{
	gint x = 0;
	gint y = 0;
	gint tile = 0;
	Board* _tmp0_;
	gint os = 0;
	gboolean _tmp1_ = FALSE;
	GdkPixbuf* _tmp8_;
#line 162 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 162 "../src/game-board-view.vala"
	g_return_if_fail (cr != NULL);
#line 163 "../src/game-board-view.vala"
	x = (c * self->priv->tilesize) + self->priv->board_x;
#line 164 "../src/game-board-view.vala"
	y = (r * self->priv->tilesize) + self->priv->board_y;
#line 165 "../src/game-board-view.vala"
	_tmp0_ = self->priv->game_board;
#line 165 "../src/game-board-view.vala"
	tile = (gint) board_get (_tmp0_, r, c);
#line 166 "../src/game-board-view.vala"
	os = 0;
#line 168 "../src/game-board-view.vala"
	if (tile == ((gint) TILE_CLEAR)) {
#line 168 "../src/game-board-view.vala"
		_tmp1_ = r != 0;
#line 651 "game-board-view.c"
	} else {
#line 168 "../src/game-board-view.vala"
		_tmp1_ = FALSE;
#line 655 "game-board-view.c"
	}
#line 168 "../src/game-board-view.vala"
	if (_tmp1_) {
#line 169 "../src/game-board-view.vala"
		return;
#line 661 "game-board-view.c"
	}
#line 171 "../src/game-board-view.vala"
	switch (tile) {
#line 171 "../src/game-board-view.vala"
		case TILE_PLAYER1:
#line 667 "game-board-view.c"
		{
#line 173 "../src/game-board-view.vala"
			if (r == 0) {
#line 671 "game-board-view.c"
				gint _tmp2_;
#line 174 "../src/game-board-view.vala"
				_tmp2_ = self->priv->offset[TILE_PLAYER1_CURSOR];
#line 174 "../src/game-board-view.vala"
				os = _tmp2_;
#line 677 "game-board-view.c"
			} else {
				gint _tmp3_;
#line 176 "../src/game-board-view.vala"
				_tmp3_ = self->priv->offset[TILE_PLAYER1];
#line 176 "../src/game-board-view.vala"
				os = _tmp3_;
#line 684 "game-board-view.c"
			}
#line 177 "../src/game-board-view.vala"
			break;
#line 688 "game-board-view.c"
		}
#line 171 "../src/game-board-view.vala"
		case TILE_PLAYER2:
#line 692 "game-board-view.c"
		{
#line 179 "../src/game-board-view.vala"
			if (r == 0) {
#line 696 "game-board-view.c"
				gint _tmp4_;
#line 180 "../src/game-board-view.vala"
				_tmp4_ = self->priv->offset[TILE_PLAYER2_CURSOR];
#line 180 "../src/game-board-view.vala"
				os = _tmp4_;
#line 702 "game-board-view.c"
			} else {
				gint _tmp5_;
#line 182 "../src/game-board-view.vala"
				_tmp5_ = self->priv->offset[TILE_PLAYER2];
#line 182 "../src/game-board-view.vala"
				os = _tmp5_;
#line 709 "game-board-view.c"
			}
#line 183 "../src/game-board-view.vala"
			break;
#line 713 "game-board-view.c"
		}
#line 171 "../src/game-board-view.vala"
		case TILE_CLEAR:
#line 717 "game-board-view.c"
		{
#line 185 "../src/game-board-view.vala"
			if (r == 0) {
#line 721 "game-board-view.c"
				gint _tmp6_;
#line 186 "../src/game-board-view.vala"
				_tmp6_ = self->priv->offset[TILE_CLEAR_CURSOR];
#line 186 "../src/game-board-view.vala"
				os = _tmp6_;
#line 727 "game-board-view.c"
			} else {
				gint _tmp7_;
#line 188 "../src/game-board-view.vala"
				_tmp7_ = self->priv->offset[TILE_CLEAR];
#line 188 "../src/game-board-view.vala"
				os = _tmp7_;
#line 734 "game-board-view.c"
			}
#line 189 "../src/game-board-view.vala"
			break;
#line 738 "game-board-view.c"
		}
		default:
#line 171 "../src/game-board-view.vala"
		break;
#line 743 "game-board-view.c"
	}
#line 192 "../src/game-board-view.vala"
	cairo_save (cr);
#line 193 "../src/game-board-view.vala"
	_tmp8_ = self->priv->pb_tileset;
#line 193 "../src/game-board-view.vala"
	gdk_cairo_set_source_pixbuf (cr, _tmp8_, (gdouble) (x - os), (gdouble) y);
#line 194 "../src/game-board-view.vala"
	cairo_rectangle (cr, (gdouble) x, (gdouble) y, (gdouble) self->priv->tilesize, (gdouble) self->priv->tilesize);
#line 196 "../src/game-board-view.vala"
	cairo_clip (cr);
#line 197 "../src/game-board-view.vala"
	cairo_paint (cr);
#line 198 "../src/game-board-view.vala"
	cairo_restore (cr);
#line 759 "game-board-view.c"
}

void
game_board_view_refresh_pixmaps (GameBoardView* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
#line 201 "../src/game-board-view.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/game-board-view.vala"
	_tmp0_ = self->priv->pb_tileset_raw;
#line 203 "../src/game-board-view.vala"
	_tmp1_ = gdk_pixbuf_scale_simple (_tmp0_, self->priv->tilesize * 6, self->priv->tilesize, GDK_INTERP_BILINEAR);
#line 203 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_tileset);
#line 203 "../src/game-board-view.vala"
	self->priv->pb_tileset = _tmp1_;
#line 204 "../src/game-board-view.vala"
	_tmp2_ = self->priv->pb_bground_raw;
#line 204 "../src/game-board-view.vala"
	_tmp3_ = gdk_pixbuf_scale_simple (_tmp2_, self->priv->boardsize, self->priv->boardsize, GDK_INTERP_BILINEAR);
#line 204 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_bground);
#line 204 "../src/game-board-view.vala"
	self->priv->pb_bground = _tmp3_;
#line 787 "game-board-view.c"
}

gboolean
game_board_view_load_pixmaps (GameBoardView* self)
{
	gboolean result = FALSE;
	gchar* fname = NULL;
	GdkPixbuf* pb_tileset_tmp = NULL;
	GdkPixbuf* pb_bground_tmp = NULL;
	GdkPixbuf* _tmp19_;
	GdkPixbuf* _tmp20_;
	Prefs* _tmp21_;
	Prefs* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	Theme _tmp25_;
	const gchar* _tmp26_;
	GdkPixbuf* _tmp40_;
	GError* _inner_error0_ = NULL;
#line 207 "../src/game-board-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 210 "../src/game-board-view.vala"
	pb_bground_tmp = NULL;
#line 213 "../src/game-board-view.vala"
	while (TRUE) {
#line 813 "game-board-view.c"
		Prefs* _tmp0_;
		Prefs* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		Theme _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 214 "../src/game-board-view.vala"
		_tmp0_ = prefs_get_instance ();
#line 214 "../src/game-board-view.vala"
		_tmp1_ = _tmp0_;
#line 214 "../src/game-board-view.vala"
		_tmp2_ = prefs_get_theme_id (_tmp1_);
#line 214 "../src/game-board-view.vala"
		_tmp3_ = _tmp2_;
#line 214 "../src/game-board-view.vala"
		_tmp4_ = theme[_tmp3_];
#line 214 "../src/game-board-view.vala"
		_tmp5_ = _tmp4_.fname_tileset;
#line 214 "../src/game-board-view.vala"
		_tmp6_ = g_build_filename (DATA_DIRECTORY, _tmp5_, NULL, NULL);
#line 214 "../src/game-board-view.vala"
		_g_free0 (fname);
#line 214 "../src/game-board-view.vala"
		fname = _tmp6_;
#line 839 "game-board-view.c"
		{
			GdkPixbuf* _tmp7_ = NULL;
			const gchar* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
#line 216 "../src/game-board-view.vala"
			_tmp8_ = fname;
#line 216 "../src/game-board-view.vala"
			_tmp9_ = gdk_pixbuf_new_from_file (_tmp8_, &_inner_error0_);
#line 216 "../src/game-board-view.vala"
			_tmp7_ = _tmp9_;
#line 216 "../src/game-board-view.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 853 "game-board-view.c"
				goto __catch5_g_error;
			}
#line 216 "../src/game-board-view.vala"
			_tmp10_ = _tmp7_;
#line 216 "../src/game-board-view.vala"
			_tmp7_ = NULL;
#line 216 "../src/game-board-view.vala"
			_g_object_unref0 (pb_tileset_tmp);
#line 216 "../src/game-board-view.vala"
			pb_tileset_tmp = _tmp10_;
#line 215 "../src/game-board-view.vala"
			_g_object_unref0 (_tmp7_);
#line 866 "game-board-view.c"
		}
		goto __finally5;
		__catch5_g_error:
		{
			GError* e = NULL;
			Prefs* _tmp11_;
			Prefs* _tmp12_;
			gint _tmp13_;
			gint _tmp14_;
#line 215 "../src/game-board-view.vala"
			e = _inner_error0_;
#line 215 "../src/game-board-view.vala"
			_inner_error0_ = NULL;
#line 218 "../src/game-board-view.vala"
			_tmp11_ = prefs_get_instance ();
#line 218 "../src/game-board-view.vala"
			_tmp12_ = _tmp11_;
#line 218 "../src/game-board-view.vala"
			_tmp13_ = prefs_get_theme_id (_tmp12_);
#line 218 "../src/game-board-view.vala"
			_tmp14_ = _tmp13_;
#line 218 "../src/game-board-view.vala"
			if (_tmp14_ != 0) {
#line 890 "game-board-view.c"
				Prefs* _tmp15_;
				Prefs* _tmp16_;
#line 219 "../src/game-board-view.vala"
				_tmp15_ = prefs_get_instance ();
#line 219 "../src/game-board-view.vala"
				_tmp16_ = _tmp15_;
#line 219 "../src/game-board-view.vala"
				prefs_set_theme_id (_tmp16_, 0);
#line 220 "../src/game-board-view.vala"
				_g_error_free0 (e);
#line 220 "../src/game-board-view.vala"
				continue;
#line 903 "game-board-view.c"
			} else {
				const gchar* _tmp17_;
#line 222 "../src/game-board-view.vala"
				_tmp17_ = fname;
#line 222 "../src/game-board-view.vala"
				game_board_view_load_error (self, _tmp17_);
#line 223 "../src/game-board-view.vala"
				result = FALSE;
#line 223 "../src/game-board-view.vala"
				_g_error_free0 (e);
#line 223 "../src/game-board-view.vala"
				_g_object_unref0 (pb_bground_tmp);
#line 223 "../src/game-board-view.vala"
				_g_object_unref0 (pb_tileset_tmp);
#line 223 "../src/game-board-view.vala"
				_g_free0 (fname);
#line 223 "../src/game-board-view.vala"
				return result;
#line 922 "game-board-view.c"
			}
#line 215 "../src/game-board-view.vala"
			_g_error_free0 (e);
#line 926 "game-board-view.c"
		}
		__finally5:
#line 215 "../src/game-board-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 931 "game-board-view.c"
			gboolean _tmp18_ = FALSE;
#line 215 "../src/game-board-view.vala"
			_g_object_unref0 (pb_bground_tmp);
#line 215 "../src/game-board-view.vala"
			_g_object_unref0 (pb_tileset_tmp);
#line 215 "../src/game-board-view.vala"
			_g_free0 (fname);
#line 215 "../src/game-board-view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 215 "../src/game-board-view.vala"
			g_clear_error (&_inner_error0_);
#line 215 "../src/game-board-view.vala"
			return _tmp18_;
#line 945 "game-board-view.c"
		}
#line 226 "../src/game-board-view.vala"
		break;
#line 949 "game-board-view.c"
	}
#line 229 "../src/game-board-view.vala"
	_tmp19_ = pb_tileset_tmp;
#line 229 "../src/game-board-view.vala"
	_tmp20_ = _g_object_ref0 (_tmp19_);
#line 229 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_tileset_raw);
#line 229 "../src/game-board-view.vala"
	self->priv->pb_tileset_raw = _tmp20_;
#line 231 "../src/game-board-view.vala"
	_tmp21_ = prefs_get_instance ();
#line 231 "../src/game-board-view.vala"
	_tmp22_ = _tmp21_;
#line 231 "../src/game-board-view.vala"
	_tmp23_ = prefs_get_theme_id (_tmp22_);
#line 231 "../src/game-board-view.vala"
	_tmp24_ = _tmp23_;
#line 231 "../src/game-board-view.vala"
	_tmp25_ = theme[_tmp24_];
#line 231 "../src/game-board-view.vala"
	_tmp26_ = _tmp25_.fname_bground;
#line 231 "../src/game-board-view.vala"
	if (_tmp26_ != NULL) {
#line 973 "game-board-view.c"
		Prefs* _tmp27_;
		Prefs* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
		Theme _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
#line 232 "../src/game-board-view.vala"
		_tmp27_ = prefs_get_instance ();
#line 232 "../src/game-board-view.vala"
		_tmp28_ = _tmp27_;
#line 232 "../src/game-board-view.vala"
		_tmp29_ = prefs_get_theme_id (_tmp28_);
#line 232 "../src/game-board-view.vala"
		_tmp30_ = _tmp29_;
#line 232 "../src/game-board-view.vala"
		_tmp31_ = theme[_tmp30_];
#line 232 "../src/game-board-view.vala"
		_tmp32_ = _tmp31_.fname_bground;
#line 232 "../src/game-board-view.vala"
		_tmp33_ = g_build_filename (DATA_DIRECTORY, _tmp32_, NULL, NULL);
#line 232 "../src/game-board-view.vala"
		_g_free0 (fname);
#line 232 "../src/game-board-view.vala"
		fname = _tmp33_;
#line 999 "game-board-view.c"
		{
			GdkPixbuf* _tmp34_ = NULL;
			const gchar* _tmp35_;
			GdkPixbuf* _tmp36_;
			GdkPixbuf* _tmp37_;
#line 234 "../src/game-board-view.vala"
			_tmp35_ = fname;
#line 234 "../src/game-board-view.vala"
			_tmp36_ = gdk_pixbuf_new_from_file (_tmp35_, &_inner_error0_);
#line 234 "../src/game-board-view.vala"
			_tmp34_ = _tmp36_;
#line 234 "../src/game-board-view.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1013 "game-board-view.c"
				goto __catch6_g_error;
			}
#line 234 "../src/game-board-view.vala"
			_tmp37_ = _tmp34_;
#line 234 "../src/game-board-view.vala"
			_tmp34_ = NULL;
#line 234 "../src/game-board-view.vala"
			_g_object_unref0 (pb_bground_tmp);
#line 234 "../src/game-board-view.vala"
			pb_bground_tmp = _tmp37_;
#line 233 "../src/game-board-view.vala"
			_g_object_unref0 (_tmp34_);
#line 1026 "game-board-view.c"
		}
		goto __finally6;
		__catch6_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp38_;
#line 233 "../src/game-board-view.vala"
			e = _inner_error0_;
#line 233 "../src/game-board-view.vala"
			_inner_error0_ = NULL;
#line 236 "../src/game-board-view.vala"
			_tmp38_ = fname;
#line 236 "../src/game-board-view.vala"
			game_board_view_load_error (self, _tmp38_);
#line 237 "../src/game-board-view.vala"
			result = FALSE;
#line 237 "../src/game-board-view.vala"
			_g_error_free0 (e);
#line 237 "../src/game-board-view.vala"
			_g_object_unref0 (pb_bground_tmp);
#line 237 "../src/game-board-view.vala"
			_g_object_unref0 (pb_tileset_tmp);
#line 237 "../src/game-board-view.vala"
			_g_free0 (fname);
#line 237 "../src/game-board-view.vala"
			return result;
#line 1053 "game-board-view.c"
		}
		__finally6:
#line 233 "../src/game-board-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1058 "game-board-view.c"
			gboolean _tmp39_ = FALSE;
#line 233 "../src/game-board-view.vala"
			_g_object_unref0 (pb_bground_tmp);
#line 233 "../src/game-board-view.vala"
			_g_object_unref0 (pb_tileset_tmp);
#line 233 "../src/game-board-view.vala"
			_g_free0 (fname);
#line 233 "../src/game-board-view.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 233 "../src/game-board-view.vala"
			g_clear_error (&_inner_error0_);
#line 233 "../src/game-board-view.vala"
			return _tmp39_;
#line 1072 "game-board-view.c"
		}
	}
#line 244 "../src/game-board-view.vala"
	_tmp40_ = pb_bground_tmp;
#line 244 "../src/game-board-view.vala"
	if (_tmp40_ != NULL) {
#line 1079 "game-board-view.c"
		GdkPixbuf* _tmp41_;
		GdkPixbuf* _tmp42_;
#line 245 "../src/game-board-view.vala"
		_tmp41_ = pb_bground_tmp;
#line 245 "../src/game-board-view.vala"
		_tmp42_ = _g_object_ref0 (_tmp41_);
#line 245 "../src/game-board-view.vala"
		_g_object_unref0 (self->priv->pb_bground_raw);
#line 245 "../src/game-board-view.vala"
		self->priv->pb_bground_raw = _tmp42_;
#line 1090 "game-board-view.c"
	} else {
		gint tilesize_raw = 0;
		gint i = 0;
		gint j = 0;
		GdkPixbuf* _tmp43_;
		GdkPixbuf* _tmp44_;
#line 250 "../src/game-board-view.vala"
		_tmp43_ = self->priv->pb_tileset_raw;
#line 250 "../src/game-board-view.vala"
		tilesize_raw = gdk_pixbuf_get_height (_tmp43_);
#line 252 "../src/game-board-view.vala"
		_tmp44_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, tilesize_raw * 7, tilesize_raw * 7);
#line 252 "../src/game-board-view.vala"
		_g_object_unref0 (self->priv->pb_bground_raw);
#line 252 "../src/game-board-view.vala"
		self->priv->pb_bground_raw = _tmp44_;
#line 1107 "game-board-view.c"
		{
			gboolean _tmp45_ = FALSE;
#line 254 "../src/game-board-view.vala"
			i = 0;
#line 254 "../src/game-board-view.vala"
			_tmp45_ = TRUE;
#line 254 "../src/game-board-view.vala"
			while (TRUE) {
#line 1116 "game-board-view.c"
				GdkPixbuf* _tmp47_;
				GdkPixbuf* _tmp48_;
#line 254 "../src/game-board-view.vala"
				if (!_tmp45_) {
#line 1121 "game-board-view.c"
					gint _tmp46_;
#line 254 "../src/game-board-view.vala"
					_tmp46_ = i;
#line 254 "../src/game-board-view.vala"
					i = _tmp46_ + 1;
#line 1127 "game-board-view.c"
				}
#line 254 "../src/game-board-view.vala"
				_tmp45_ = FALSE;
#line 254 "../src/game-board-view.vala"
				if (!(i < 7)) {
#line 254 "../src/game-board-view.vala"
					break;
#line 1135 "game-board-view.c"
				}
#line 255 "../src/game-board-view.vala"
				_tmp47_ = self->priv->pb_tileset_raw;
#line 255 "../src/game-board-view.vala"
				_tmp48_ = self->priv->pb_bground_raw;
#line 255 "../src/game-board-view.vala"
				gdk_pixbuf_copy_area (_tmp47_, tilesize_raw * 3, 0, tilesize_raw, tilesize_raw, _tmp48_, i * tilesize_raw, 0);
#line 1143 "game-board-view.c"
				{
					gboolean _tmp49_ = FALSE;
#line 258 "../src/game-board-view.vala"
					j = 1;
#line 258 "../src/game-board-view.vala"
					_tmp49_ = TRUE;
#line 258 "../src/game-board-view.vala"
					while (TRUE) {
#line 1152 "game-board-view.c"
						GdkPixbuf* _tmp51_;
						GdkPixbuf* _tmp52_;
#line 258 "../src/game-board-view.vala"
						if (!_tmp49_) {
#line 1157 "game-board-view.c"
							gint _tmp50_;
#line 258 "../src/game-board-view.vala"
							_tmp50_ = j;
#line 258 "../src/game-board-view.vala"
							j = _tmp50_ + 1;
#line 1163 "game-board-view.c"
						}
#line 258 "../src/game-board-view.vala"
						_tmp49_ = FALSE;
#line 258 "../src/game-board-view.vala"
						if (!(j < 7)) {
#line 258 "../src/game-board-view.vala"
							break;
#line 1171 "game-board-view.c"
						}
#line 259 "../src/game-board-view.vala"
						_tmp51_ = self->priv->pb_tileset_raw;
#line 259 "../src/game-board-view.vala"
						_tmp52_ = self->priv->pb_bground_raw;
#line 259 "../src/game-board-view.vala"
						gdk_pixbuf_copy_area (_tmp51_, tilesize_raw * 2, 0, tilesize_raw, tilesize_raw, _tmp52_, i * tilesize_raw, j * tilesize_raw);
#line 1179 "game-board-view.c"
					}
				}
			}
		}
	}
#line 268 "../src/game-board-view.vala"
	result = TRUE;
#line 268 "../src/game-board-view.vala"
	_g_object_unref0 (pb_bground_tmp);
#line 268 "../src/game-board-view.vala"
	_g_object_unref0 (pb_tileset_tmp);
#line 268 "../src/game-board-view.vala"
	_g_free0 (fname);
#line 268 "../src/game-board-view.vala"
	return result;
#line 1195 "game-board-view.c"
}

static gboolean
game_board_view_real_button_press_event (GtkWidget* base,
                                         GdkEventButton* e)
{
	GameBoardView * self;
	gboolean result = FALSE;
	gint x = 0;
	GdkWindow* _tmp0_;
	GdkDevice* _tmp1_;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
#line 282 "../src/game-board-view.vala"
	self = (GameBoardView*) base;
#line 282 "../src/game-board-view.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 284 "../src/game-board-view.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 284 "../src/game-board-view.vala"
	_tmp1_ = e->device;
#line 284 "../src/game-board-view.vala"
	gdk_window_get_device_position (_tmp0_, _tmp1_, &_tmp2_, NULL, NULL);
#line 284 "../src/game-board-view.vala"
	x = _tmp2_;
#line 285 "../src/game-board-view.vala"
	g_signal_emit (self, game_board_view_signals[GAME_BOARD_VIEW_COLUMN_CLICKED_SIGNAL], 0, game_board_view_get_column (self, x), &_tmp3_);
#line 285 "../src/game-board-view.vala"
	result = _tmp3_;
#line 285 "../src/game-board-view.vala"
	return result;
#line 1227 "game-board-view.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__INT (GClosure * closure,
                                      GValue * return_value,
                                      guint n_param_values,
                                      const GValue * param_values,
                                      gpointer invocation_hint,
                                      gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__INT) (gpointer data1, gint arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 22 "../src/game-board-view.vala"
	g_return_if_fail (return_value != NULL);
#line 22 "../src/game-board-view.vala"
	g_return_if_fail (n_param_values == 2);
#line 22 "../src/game-board-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 22 "../src/game-board-view.vala"
		data1 = closure->data;
#line 22 "../src/game-board-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 1255 "game-board-view.c"
	} else {
#line 22 "../src/game-board-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 22 "../src/game-board-view.vala"
		data2 = closure->data;
#line 1261 "game-board-view.c"
	}
#line 22 "../src/game-board-view.vala"
	callback = (GMarshalFunc_BOOLEAN__INT) (marshal_data ? marshal_data : cc->callback);
#line 22 "../src/game-board-view.vala"
	v_return = callback (data1, g_value_get_int (param_values + 1), data2);
#line 22 "../src/game-board-view.vala"
	g_value_set_boolean (return_value, v_return);
#line 1269 "game-board-view.c"
}

static void
game_board_view_class_init (GameBoardViewClass * klass,
                            gpointer klass_data)
{
#line 22 "../src/game-board-view.vala"
	game_board_view_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/game-board-view.vala"
	g_type_class_adjust_private_offset (klass, &GameBoardView_private_offset);
#line 22 "../src/game-board-view.vala"
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) game_board_view_real_configure_event;
#line 22 "../src/game-board-view.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) game_board_view_real_draw;
#line 22 "../src/game-board-view.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) game_board_view_real_button_press_event;
#line 22 "../src/game-board-view.vala"
	G_OBJECT_CLASS (klass)->finalize = game_board_view_finalize;
#line 1288 "game-board-view.c"
	/**
	     * column_clicked:
	     *
	     * emited when a column on the game board is clicked
	     *
	     * @column:
	     *
	     * Which column was clicked on
	     */
#line 22 "../src/game-board-view.vala"
	game_board_view_signals[GAME_BOARD_VIEW_COLUMN_CLICKED_SIGNAL] = g_signal_new ("column-clicked", TYPE_GAME_BOARD_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__INT, G_TYPE_BOOLEAN, 1, G_TYPE_INT);
#line 1300 "game-board-view.c"
}

static void
game_board_view_instance_init (GameBoardView * self,
                               gpointer klass)
{
#line 22 "../src/game-board-view.vala"
	self->priv = game_board_view_get_instance_private (self);
#line 23 "../src/game-board-view.vala"
	self->priv->boardsize = 0;
#line 24 "../src/game-board-view.vala"
	self->priv->tilesize = 0;
#line 1313 "game-board-view.c"
}

static void
game_board_view_finalize (GObject * obj)
{
	GameBoardView * self;
#line 22 "../src/game-board-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME_BOARD_VIEW, GameBoardView);
#line 27 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_tileset_raw);
#line 28 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_bground_raw);
#line 30 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_tileset);
#line 31 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->pb_bground);
#line 32 "../src/game-board-view.vala"
	_g_object_unref0 (self->priv->game_board);
#line 22 "../src/game-board-view.vala"
	G_OBJECT_CLASS (game_board_view_parent_class)->finalize (obj);
#line 1334 "game-board-view.c"
}

GType
game_board_view_get_type (void)
{
	static volatile gsize game_board_view_type_id__volatile = 0;
	if (g_once_init_enter (&game_board_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameBoardViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_board_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameBoardView), 0, (GInstanceInitFunc) game_board_view_instance_init, NULL };
		GType game_board_view_type_id;
		game_board_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "GameBoardView", &g_define_type_info, 0);
		GameBoardView_private_offset = g_type_add_instance_private (game_board_view_type_id, sizeof (GameBoardViewPrivate));
		g_once_init_leave (&game_board_view_type_id__volatile, game_board_view_type_id);
	}
	return game_board_view_type_id__volatile;
}

